



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java数组与泛型</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java数组与泛型</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 18:38:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Java中不能创建泛型数组，例如不能这样写：<br />[java] view plaincopy<br />ArrayList&lt;String&gt;[] as = new ArrayList&lt;String&gt;[10];</p>
<p>原因是：<br />Java中的泛型并不像C++那样会在编译时实例化成具体的类，或者说Java中的泛型是&ldquo;伪泛型&rdquo;。对于一个泛型，程序无法获得它的具体的参数类型，也就是说：<br />[java] view plaincopy<br />ArrayList&lt;String&gt; a = new ArrayList&lt;String&gt;();</p>
<p>声明a之后，你没法检查a的类型是ArrayList&lt;String&gt;还是ArrayList&lt;Integer&gt;，只能知道a是ArrayList的一个实例化对象。如下代码：<br />[java] view plaincopy<br />System.out.println(a.getClass().toString());  <br />System.out.println(Arrays.toString(a.getClass().getTypeParameters()));</p>
<p>得到的输出信息是：<br />class java.util.ArrayList<br />[E]<br />可以看出，获得a的具体类型的企图落空了。<br />泛型的这种机制在Java中叫做擦除。即，泛型的具体类型信息会被擦除到它的原生类型或者类型边界。类型边界是Java泛型的另一个特性：<br />[java] view plaincopy<br />class Temp&lt;T extends Par&gt;  <br />{...}</p>
<p>Temp是泛型的名字，Par是边界类的名字。在定义一个泛型的时候，可以通过extends关键词来指定T的导出类型（T的父类），擦除的时候，会擦除到边界，即Par。<br />而Java中的数组必须知道它所持有的确切类型。<br />数组名是一个标识符，是一个指向堆栈中的数组对象的引用。如果是基本数据类型的数组，那么这个数组对象中存放着length等信息以及各个元素的值，如果是引用类型的数组，那么这个数组对象中存放着length等信息以及各个元素的引用。数组在定义时就必须有确切的类型，所有存入数组的元素都必须转化成数组的类型。所以Java中泛型和数组可谓水火不相容。<br />版权声明：本文为博主原创文章，未经博主允许不得转载。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqd61x8d.html">SQL Server导入数据时&OpenCurlyDoubleQuote;启用标示插入&rdquo;详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jrzmlq.html">strtoull函数的使用，及相关信息汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m6j2p9.html">repo 版本回退</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4x4r38.html">RO05 - 如何编写RemObjects SDK服务端 &lpar;Delphi Version&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y453eq.html">lua标签解析器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y40j3q.html">总结Selenium自动化测试方法（二）测试环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmvk609.html">Components of the Impala Server</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okwzmx9.html">An exception occurred during configuration of persistence layer&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg7mmr8.html">Linux学习--&amp;gt&semi;linux系统在移动硬盘的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/960jxjn9.html">android spf 存储 集合（实体等）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyklk19.html">【2018&period;05&period;10 智能驾驶&sol;汽车电子】AutoSar Database-ARXML及Vector Database-DBC的对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwk4548.html">Java8新特性（待更新&period;&period;&period;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy3myd9.html">ShareSVN授权的代码示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/960kwyn9.html">Tpcc-MySQL对mysql数据库进行性能测试报告、分析及使用gnuplot生成图表展示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyz74gq.html">jq-杂记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpmw149.html">nginx静态资源缓存策略配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1564e9.html">MySQL集群Percona XtraDB Cluster安装搭建步骤详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pkzr0q.html">Thread 1 cannot allocate new log的问题分析 &lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj25wzq.html">QTreeView&sol;QTableView中利用QStandardItem实现复选框三种形态变化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnokxmq.html">hdu-4725-The Shortest Path in Nya Graph-层次网络</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qljeop19.html">json格式字符串与java&period;util&period;Map的互转&lpar;借助于jackson&period;jar&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1km5w09.html">补全aaz288 可能有问题的过程 P&lowbar;COMPL&lowbar;AAZ288</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv15z4jq.html">java读写</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kml0z9.html">skin&plus;&plus; 终极破解之法</a>
			</li>
						<li><a href="https://www.batexi.com/a/950rw468.html">pkusc2015</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1w6l2q.html">VC问题 IntelliSense&colon;&OpenCurlyDoubleQuote;没有可用的附加信息&rdquo;，&lbrack;请参见&OpenCurlyDoubleQuote;C&plus;&plus;项目 IntelliSense 疑难解答&rdquo;，获得进一步的帮助&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m7ko38.html">java笔记之数据类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdnvpk9.html">在AD09中查找元件和封装</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pj4m38.html">非root不能gdb attach的限制</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zxj5j9.html">STL中deque</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
